local IconLoot = Apollo.GetAddon("IconLoot")
local DaiGUI = Apollo.GetPackage("DaiGUI-1.0").tPackage
local ktFormDefinitions

function IconLoot:FactoryProduce(strFormName, wndParent, tObject)
	local wndNew
  
  if wndParent ~= nil and type(wndParent) ~= "string" and tObject ~= nil then
    wndNew = wndParent:FindChildByUserData(tObject)
  end
  
	if not wndNew then
    wndNew = DaiGUI:Create(ktFormDefinitions[strFormName]):GetInstance(self, wndParent)
    wndNew:SetData(tObject)
	end
	return wndNew
end

ktFormDefinitions = {
  --
  IconLootForm = {
    AnchorOffsets = { 70, -130, 423, 260 },
    AnchorPoints = "VCENTER",
    RelativeToClient = true, 
    Name = "IconLootForm", 
    SwallowMouseClicks = true, 
    Overlapped = true, 
    IgnoreMouse = true, 
    Events = {
      WindowSizeChanged = "OnIconLootWindowResized",
    },
    Children = {
      {
        AnchorOffsets = { 0, 0, 0, 26 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_InterfaceLarge_BO", 
        Name = "CashComplex", 
        IgnoreMouse = true, 
        TransitionShowHide = true, 
        Children = {
          {
            AnchorOffsets = { 0, 0, 12, 0 },
            AnchorPoints = "VFILL",
            RelativeToClient = true, 
            Font = "CRB_InterfaceLarge_BO", 
            Name = "CashLabel", 
            TextId = "CRB__1", 
            DT_VCENTER = true, 
            Visible = false, 
          },
          {
            AnchorOffsets = { 12, 0, 0, 0 },
            AnchorPoints = "FILL",
            Class = "CashWindow", 
            RelativeToClient = true, 
            Font = "CRB_InterfaceLarge_BO", 
            Name = "CashDisplay", 
            IgnoreMouse = true, 
            SkipZeroes = true, 
          },
        },
      },
      {
        AnchorOffsets = { 0, 26, 0, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "LootedItemScroll", 
      },
      {
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "Anchor", 
        Visible = false, 
        Sprite = "BK3:UI_BK3_Holo_InsetFramed", 
        Picture = true, 
        IgnoreMouse = true, 
        NewWindowDepth = 1, 
        Overlapped = true, 
        Children = {
          {
            AnchorOffsets = { -34, 5, -4, 35 },
            AnchorPoints = "TOPRIGHT",
            Class = "Button", 
            Base = "BK3:btnHolo_Close", 
            Font = "CRB_Pixel", 
            ButtonType = "PushButton", 
            DT_VCENTER = true, 
            DT_CENTER = true, 
            Name = "LockBtn", 
            NormalTextColor = "UI_BtnTextRedNormal", 
            PressedTextColor = "UI_BtnTextRedPressed", 
            FlybyTextColor = "UI_BtnTextRedFlyby", 
            PressedFlybyTextColor = "UI_BtnTextRedPressedFlyby", 
            DisabledTextColor = "UI_BtnTextRedDisabled", 
            Events = {
              ButtonSignal = "OnAnchorLockBtn",
            },
          },
          {
            AnchorOffsets = { -91, -58, 91, 104 },
            AnchorPoints = "CENTER",
            RelativeToClient = true, 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "Inset", 
            Picture = true, 
            IgnoreMouse = true, 
            Sprite = "BK3:sprMetal_Scroll_Framing", 
            Pixies = {
              { AnchorOffsets = { 0, 11, 0, 31 }, AnchorPoints = "HFILL", BGColor = "white", TextColor = "white", Font = "CRB_Interface12_BBO", DT_CENTER = true, DT_VCENTER = true, DT_SINGLELINE = true, Text = "IconLoot", },
            },
            Children = {
              {
                AnchorOffsets = { -70, -42, 63, 16 },
                AnchorPoints = "CENTER",
                Class = "Button", 
                Base = "BK3:btnHolo_Blue_Med", 
                Font = "CRB_Pixel", 
                ButtonType = "PushButton", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                Name = "TestBtn", 
                NormalTextColor = "UI_BtnTextBlueNormal", 
                PressedTextColor = "UI_BtnTextBluePressed", 
                FlybyTextColor = "UI_BtnTextBlueFlyby", 
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby", 
                DisabledTextColor = "UI_BtnTextBlueDisabled", 
                Text = "Test Items", 
                Events = {
                  ButtonSignal = "OnAnchorTestBtn",
                },
              },
              {
                AnchorOffsets = { -59, 10, 63, 42 },
                AnchorPoints = "CENTER",
                Class = "Button", 
                Base = "BK3:btnHolo_Check", 
                Font = "CRB_Pixel", 
                ButtonType = "Check", 
                DT_VCENTER = true, 
                Name = "CompactModeBtn", 
                Text = "  Compact Mode", 
                DrawAsCheckbox = true, 
                Events = {
                  ButtonCheck = "OnAnchorCompactModeToggle",
                  ButtonUncheck = "OnAnchorCompactModeToggle",
                },
              },
              {
                AnchorOffsets = { -59, 38, 63, 70 },
                AnchorPoints = "CENTER",
                Class = "Button", 
                Base = "BK3:btnHolo_Check", 
                Font = "CRB_Pixel", 
                ButtonType = "Check", 
                DT_VCENTER = true, 
                Name = "GrowDirectionBtn", 
                Text = "  Grow Upwards", 
                DrawAsCheckbox = true, 
                Events = {
                  ButtonCheck = "OnAnchorGrowDirectionToggle",
                  ButtonUncheck = "OnAnchorGrowDirectionToggle",
                },
              },
              {
                AnchorOffsets = { -90, 39, 90, 44 },
                AnchorPoints = "HCENTER",
                RelativeToClient = true, 
                BGColor = "xkcdAlgae", 
                TextColor = "UI_WindowTextDefault", 
                Name = "Divider", 
                Picture = true, 
                IgnoreMouse = true, 
                Sprite = "CRB_Tooltips:sprTooltip_HorzDividerLine", 
              },
            },
          },
        },
      },
      {
        AnchorOffsets = { 10, -24, 348, 263 },
        AnchorPoints = "TOPRIGHT",
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "NotificationOptions", 
        Sprite = "BK3:UI_BK3_Holo_Framing_3", 
        Picture = true, 
        IgnoreMouse = true, 
        NoClip = true, 
        Visible = false, 
        Pixies = {
          { AnchorOffsets = { 0, 30, 0, 50 }, AnchorPoints = "HFILL", BGColor = "white", TextColor = "white", Font = "CRB_Interface12_BBO", Text = "Notification Options", DT_CENTER = true, DT_VCENTER = true, },
        },
        Children = {
          {
            AnchorOffsets = { -140, 59, 140, 64 },
            AnchorPoints = "HCENTER",
            RelativeToClient = true, 
            BGColor = "xkcdAlgaeGreen", 
            TextColor = "UI_WindowTextDefault", 
            Name = "Divider", 
            Picture = true, 
            IgnoreMouse = true, 
            Sprite = "CRB_Tooltips:sprTooltip_HorzDividerLine", 
          },
          {
            AnchorOffsets = { -102, 65, 102, 89 },
            AnchorPoints = "HCENTER",
            RelativeToClient = true, 
            Font = "CRB_Pixel_O", 
            Text = "Minimum item quality", 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "ItemQualityLabel", 
            DT_VCENTER = true, 
            DT_CENTER = true, 
          },
          {
            AnchorOffsets = { -120, 93, 120, 117 },
            AnchorPoints = "HCENTER",
            RelativeToClient = true, 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "ItemQualities", 
						NoClip = true,
            Pixies = {
              { AnchorOffsets = { 216, 0, 240, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Artifact", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 180, 0, 204, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Legendary", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 144, 0, 168, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Superb", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 108, 0, 132, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Excellent", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 72, 0, 96, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Good", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 36, 0, 60, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Average", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
              { AnchorOffsets = { 0, 0, 24, 0 }, AnchorPoints = "VFILL", BGColor = "ItemQuality_Inferior", TextColor = "UI_WindowTextDefault", Sprite = "BasicSprites:WhiteFill", },
            },
            Children = {
              {
                AnchorOffsets = { -9, -10, 33, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityInferiorBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 27, -10, 69, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityAverageBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 63, -10, 105, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityGoodBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 99, -10, 141, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityExcellentBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 135, -10, 177, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualitySuperbBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 171, -10, 213, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityLegendaryBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
              {
                AnchorOffsets = { 207, -10, 249, 10 },
                AnchorPoints = "VFILL",
                Class = "Button", 
                Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue", 
                Font = "DefaultButton", 
                ButtonType = "Check", 
                RadioGroup = "IconLoot_NotifyItemQuality", 
                DT_VCENTER = true, 
                DT_CENTER = true, 
                BGColor = "UI_BtnBGDefault", 
                TextColor = "UI_BtnTextDefault", 
                NormalTextColor = "UI_BtnTextDefault", 
                PressedTextColor = "UI_BtnTextDefault", 
                FlybyTextColor = "UI_BtnTextDefault", 
                PressedFlybyTextColor = "UI_BtnTextDefault", 
                DisabledTextColor = "UI_BtnTextDefault", 
                Name = "ItemQualityArtifactBtn", 
                NoClip = true, 
                GlobalRadioGroup = "", 
                RadioAlwaysSignal = false, 
                RadioDisallowNonSelection = true, 
                TooltipFont = "Default", 
                Overlapped = true, 
                Events = {
                  ButtonCheck = "OnAnchorNotificationItemQuality",
                },
              },
            },
          },
          {
            AnchorOffsets = { -102, 132, 102, 164 },
            AnchorPoints = "HCENTER",
            Class = "Button", 
            Base = "BK3:btnHolo_Check", 
            Font = "CRB_Pixel", 
            ButtonType = "Check", 
            DT_VCENTER = true, 
            Name = "QuestItemBtn", 
            Text = "  Notify on quest items", 
            DrawAsCheckbox = true, 
            Events = {
              ButtonCheck = "OnAnchorNotifyQuestItems",
              ButtonUncheck = "OnAnchorNotifyQuestItems",
            },
          },
          {
            AnchorOffsets = { -102, 160, 128, 192 },
            AnchorPoints = "HCENTER",
            Class = "Button", 
            Base = "BK3:btnHolo_Check", 
            Font = "CRB_Pixel", 
            ButtonType = "Check", 
            DT_VCENTER = true, 
            Name = "HarvestItemBtn", 
            Text = "  Notify on quality harvested items", 
            DrawAsCheckbox = true, 
            Events = {
              ButtonCheck = "OnAnchorNotifyHarvestItems",
              ButtonUncheck = "OnAnchorNotifyHarvestItems",
            },
          },
          {
            AnchorOffsets = { -89, 226, 89, 246 },
            AnchorPoints = "HCENTER",
            Class = "SliderBar", 
            RelativeToClient = true, 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Template = "CRB_Scroll_HoloLarge", 
            Name = "NotificationTimeoutSlider", 
            UseButtons = true, 
            Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo", 
            Min = 1.500000, 
            Max = 5.000000, 
            TickAmount = 0.100000, 
            InitialValue = 3.000000, 
            Border = true, 
            Events = {
              SliderBarChanged = "OnNotificationTimeoutSliderChanged",
            },
            Children = {
              {
                AnchorOffsets = { -30, 0, -5, 0 },
                AnchorPoints = "VFILL",
                RelativeToClient = true, 
                Font = "CRB_Pixel_O", 
                Text = 3.0, 
                BGColor = "UI_WindowBGDefault", 
                TextColor = "UI_WindowTextDefault", 
                Name = "NotificationTimeoutLabel", 
                IgnoreMouse = true, 
                NoClip = true, 
                DT_CENTER = true, 
                DT_VCENTER = true, 
              },
            },
          },
          {
            AnchorOffsets = { -102, 205, 102, 225 },
            AnchorPoints = "HCENTER",
            RelativeToClient = true, 
            Font = "CRB_Pixel_O", 
            Text = "Notification time", 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "NTLabel", 
            DT_CENTER = true, 
            DT_VCENTER = true, 
          },
        },
      },
    },
  },
  --
  LootedItem = {
    AnchorOffsets = { 0, 0, 0, 58 },
    AnchorPoints = "HFILL",
    RelativeToClient = true, 
    Font = "CRB_InterfaceMedium_B", 
    Name = "LootedItem", 
    DT_VCENTER = true, 
    DT_WORDBREAK = true, 
    Picture = true, 
    IgnoreMouse = true, 
    TransitionShowHide = true, 
    Children = {
      {
        AnchorOffsets = { 67, 10, -135, 30 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_InterfaceLarge_O", 
        Name = "Name_Text", 
        SwallowMouseClicks = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 67, 30, -135, 50 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_InterfaceSmall_O", 
        Name = "Type_Text", 
        SwallowMouseClicks = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { -119, 5, 0, 55 },
        AnchorPoints = "TOPRIGHT",
        Font = "CRB_FloaterSmall", 
        Name = "Count", 
        DT_VCENTER = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 0, 4, 50, -4 },
        AnchorPoints = "VFILL",
        RelativeToClient = true, 
        Name = "LootIconBorder", 
        Sprite = "CRB_Tooltips:sprTooltip_SquareFrame_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
        NewWindowDepth = 1, 
      },
      {
        AnchorOffsets = { 4, 8, 46, 50 },
        RelativeToClient = true, 
        Name = "LootIcon", 
        Picture = true, 
        IgnoreMouse = true, 
        Sprite = "ClientSprites:GroupLootIcon", 
        IgnoreTooltipDelay = true, 
      },
      {
        AnchorOffsets = { 42, -12, -112, 69 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Name = "ItemBG", 
        Sprite = "CRB_Tooltips:sprTooltip_Header_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
        Children = {
          {
            AnchorOffsets = { 4, 5, -4, -5 },
            AnchorPoints = "FILL",
            RelativeToClient = true, 
            Name = "TextBG", 
            Sprite = "CRB_ChatLogSprites:sprChatBackground", 
            Picture = true, 
            IgnoreMouse = true, 
            Visible = false, 
          },
        },
      },
      {
        AnchorOffsets = { 72, 50, -140, 58 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Name = "ItemBar", 
        Sprite = "CRB_Tooltips:sprTooltip_RarityBar_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 0, 0, -125, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "Block", 
        Events = {
          GenerateTooltip = "OnTooltip",
        },
      },
    },
  },


  --
  MinLootedItem = {
    AnchorOffsets = { 0, 0, -15, 42 },
    AnchorPoints = "HFILL",
    RelativeToClient = true, 
    Font = "CRB_InterfaceMedium_B", 
    Name = "MinLootedItem", 
    DT_VCENTER = true, 
    DT_WORDBREAK = true, 
    Picture = true, 
    IgnoreMouse = true, 
    TransitionShowHide = true, 
    Visible = false, 
    Children = {
      {
        AnchorOffsets = { 51, 10, -135, 30 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_InterfaceLarge_O", 
        Name = "Name_Text", 
        SwallowMouseClicks = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 75, 30, -135, 50 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_InterfaceSmall_O", 
        Name = "Type_Text", 
        SwallowMouseClicks = true, 
        TextId = "Guild_ThatCharterIsNoLongerValid", 
        IgnoreMouse = true, 
        Visible = false, 
      },
      {
        AnchorOffsets = { -119, 4, 0, -4 },
        AnchorPoints = "VFILLRIGHT",
        Font = "CRB_Dialog_I", 
        Name = "Count", 
        DT_VCENTER = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 0, 4, 34, 38 },
        RelativeToClient = true, 
        Name = "LootIconBorder", 
        Sprite = "CRB_Tooltips:sprTooltip_SquareFrame_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
        NoClip = true, 
        NewWindowDepth = 1, 
      },
      {
        AnchorOffsets = { 4, 8, 30, -8 },
        AnchorPoints = "VFILL",
        RelativeToClient = true, 
        Name = "LootIcon", 
        Picture = true, 
        IgnoreMouse = true, 
        Sprite = "IconSprites:Icon_ItemWeapon_2H_Sword_01", 
        IgnoreTooltipDelay = true, 
      },
      {
        AnchorOffsets = { 27, -12, -125, 53 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Name = "ItemBG", 
        Sprite = "CRB_Tooltips:sprTooltip_Header_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
        Children = {
          {
            AnchorOffsets = { 20, 20, -20, -20 },
            AnchorPoints = "FILL",
            RelativeToClient = true, 
            Name = "TextBG", 
            Sprite = "CRB_ChatLogSprites:sprChatBackground", 
            Picture = true, 
            IgnoreMouse = true, 
          },
        },
      },
      {
        AnchorOffsets = { 56, 34, -140, 42 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Name = "ItemBar", 
        Sprite = "CRB_Tooltips:sprTooltip_RarityBar_Silver", 
        Picture = true, 
        IgnoreMouse = true, 
      },
      {
        AnchorOffsets = { 0, 0, -125, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        Name = "Block", 
        Events = {
          GenerateTooltip = "OnTooltip",
        },
      },
    },
  },


  -- 
  LootNotificationForm = {
    AnchorOffsets = { -238, -305, 238, -135 },
    AnchorPoints = "CENTER",
    RelativeToClient = true, 
    BGColor = "UI_WindowBGDefault", 
    TextColor = "UI_WindowTextDefault", 
    Template = "Holo_List", 
    Name = "LootNotificationForm", 
    Border = true, 
    Picture = true, 
    SwallowMouseClicks = true, 
    Moveable = true, 
    Escapable = true, 
    Overlapped = true, 
    UseTemplateBG = true, 
    Children = {
      {
        AnchorOffsets = { 92, -2, 10, 18 },
        AnchorPoints = "FILL",
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "ItemDetails", 
        Children = {
          {
            AnchorOffsets = { 0, -32, -10, 4 },
            AnchorPoints = { 0, 0.5, 1, 0.5 },
            RelativeToClient = true, 
            Font = "CRB_Interface12_BBO", 
            Text = "Super Awesome Plasmasaw", 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_BtnTextGrayOrangeListPressed", 
            Name = "ItemName", 
            DT_VCENTER = true, 
          },
          {
            AnchorOffsets = { 0, -10, -10, 15 },
            AnchorPoints = { 0, 0.5, 1, 0.5 },
            RelativeToClient = true, 
            Font = "CRB_Interface9_BB", 
            Text = "Item Type", 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "ItemType", 
            DT_VCENTER = true, 
            IgnoreMouse = true, 
            NoClip = true, 
          },
        },
      },
      {
        AnchorOffsets = { -36, -26, 17, 10 },
        AnchorPoints = "BOTTOMRIGHT",
        RelativeToClient = true, 
        Font = "CRB_Interface12_BBO", 
        Text = "x5", 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "ItemCount", 
        IgnoreMouse = true, 
        NoClip = true, 
        DT_CENTER = true, 
        Visible = false, 
        DT_VCENTER = true, 
      },
      {
        AnchorOffsets = { 75, 97, -75, 105 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "RarityBar", 
        Sprite = "CRB_Tooltips:sprTooltip_RarityBar_Pink", 
        Picture = true, 
        IgnoreMouse = true, 
        NoClip = true, 
        TestAlpha = true,
      },
      {
        AnchorOffsets = { -133, -43, 133, -17 },
        AnchorPoints = "HCENTER",
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "QuestItem", 
        Picture = true, 
        IgnoreMouse = true, 
        Sprite = "CRB_Tooltips:sprTooltip_Header", 
        NoClip = true, 
        Visible = false, 
        TestAlpha = true,
        Children = {
          {
            AnchorOffsets = { 24, -20, 56, 17 },
            AnchorPoints = "VCENTER",
            RelativeToClient = true, 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "QuestIcon", 
            Sprite = "CRB_MegamapSprites:sprMap_IconCompletion_EpisodeQuest", 
            Picture = true, 
            IgnoreMouse = true, 
            NoClip = true, 
          },
          {
            AnchorOffsets = { 60, -1, 22, -1 },
            AnchorPoints = "FILL",
            RelativeToClient = true, 
            Font = "CRB_Interface12_I", 
            Text = "This item starts a quest", 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "xkcdGoldenYellow", 
            Name = "ItemStartQuestText", 
            DT_VCENTER = true, 
          },
        },
      },
      {
        AnchorOffsets = { -17, -8, 7, 16 },
        AnchorPoints = { 1, 0, 1, 0 },
        Class = "Button", 
        Base = "BK3:btnHolo_Close", 
        Font = "DefaultButton", 
        ButtonType = "PushButton", 
        DT_VCENTER = true, 
        DT_CENTER = true, 
        BGColor = "UI_BtnBGDefault", 
        TextColor = "UI_BtnTextDefault", 
        NormalTextColor = "UI_BtnTextDefault", 
        PressedTextColor = "UI_BtnTextDefault", 
        FlybyTextColor = "UI_BtnTextDefault", 
        PressedFlybyTextColor = "UI_BtnTextDefault", 
        DisabledTextColor = "UI_BtnTextDefault", 
        Name = "CloseBtn", 
        NoClip = true, 
        Events = {
          ButtonSignal = "OnNotificationCloseBtn",
        },
      },
      {
        AnchorOffsets = { 8, 8, 74, 74 },
        RelativeToClient = true, 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "Icon", 
        Picture = true, 
        Sprite = "IconSprites:Icon_ItemMisc_LaserChainsaw", 
        IgnoreTooltipDelay = true,
        Events = {
          GenerateTooltip = "OnTooltip",
        },
        Children = {
          {
            AnchorOffsets = { -18, -52, 84, 51 },
            AnchorPoints = "VCENTER",
            RelativeToClient = true, 
            BGColor = "UI_WindowBGDefault", 
            TextColor = "UI_WindowTextDefault", 
            Name = "IconBorder", 
            Picture = true, 
            IgnoreMouse = true, 
            Sprite = "ItemQualityBrackets:sprItemQualityBracket_Silver", 
            NoClip = true, 
          },
        },
      },
      {
        AnchorOffsets = { 0, -17, 0, 22 },
        AnchorPoints = "HFILL",
        RelativeToClient = true, 
        Font = "CRB_FloaterSmall", 
        Text = "Loot Notification", 
        BGColor = "UI_WindowBGDefault", 
        TextColor = "UI_WindowTextDefault", 
        Name = "Title", 
        DT_CENTER = true, 
        DT_VCENTER = true, 
        NoClip = true,
        TestAlpha = true,
      },
    },
  },
}
